/*******************************************************************************
 * FoxGRI_OS generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxGRI_OS extends FoxGRI_BO
    native
    config(Game)
    hidecategories(Navigation,Movement,Collision);

enum EOSTokenType
{
    EOSTT_Bronze,
    EOSTT_Silver,
    EOSTT_Gold,
    EOSTT_MAX
};

var transient int CurrentWaveIndex;
var transient int LastCompletedWave;
var transient int TotalWaves;
var repnotify transient bool bWaveStarted;
var transient bool bPointActive;
var transient bool bFirstWaveSpawned;
var repnotify transient int CurrentWaveTotalEnemies;
var transient int CurrentWaveKilledEnemies;
var transient int CurrentWaveSpawnedEnemies;
var transient int SubWaveIndex;
var transient int TotalSubWaves;
var transient int SubWaveNumEnemies;
var transient int UIEstablishingTime;
var transient int UIScanningTime;
var transient int ActivatedObjectiveCount;
var transient int EarnedTokens[EOSTokenType];
var transient UniqueNetId PlayersJoined[4];

replication
{
    // Pos:0x000
    if(bNetDirty && Role == ROLE_Authority)
        CurrentWaveIndex, CurrentWaveKilledEnemies, 
        CurrentWaveSpawnedEnemies, CurrentWaveTotalEnemies, 
        EarnedTokens, LastCompletedWave, 
        PlayersJoined, SubWaveIndex, 
        SubWaveNumEnemies, TotalSubWaves, 
        TotalWaves, UIEstablishingTime, 
        UIScanningTime, bPointActive, 
        bWaveStarted
}

simulated function PostBeginPlay()
{
    super(FoxGRI).PostBeginPlay();
    // End:0x28
    if(Role == ROLE_Authority)
    {
        GetStoredGameInfo();
    }
    //return;    
}

function GetStoredGameInfo()
{
    local FoxGameSettings_OS GameSettingsOS;

    GameSettingsOS = FoxGameSettings_OS(class'GameEngine'.static.GetOnlineSubsystem().GameInterface.GetGameSettings('Game'));
    // End:0x22E
    if(GameSettingsOS != none)
    {
        CurrentWaveIndex = GameSettingsOS.CurrentWaveIndex;
        LastCompletedWave = GameSettingsOS.LastCompletedWave;
        TotalWaves = GameSettingsOS.TotalWaves;
        CurrentWaveTotalEnemies = GameSettingsOS.CurrentWaveTotalEnemies;
        CurrentWaveKilledEnemies = GameSettingsOS.CurrentWaveKilledEnemies;
        CurrentWaveSpawnedEnemies = GameSettingsOS.CurrentWaveSpawnedEnemies;
        GameSettingsOS.SubWaveIndex = SubWaveIndex;
        GameSettingsOS.TotalSubWaves = TotalSubWaves;
        GameSettingsOS.SubWaveNumEnemies = SubWaveNumEnemies;
        UIEstablishingTime = GameSettingsOS.UIEstablishingTime;
        UIScanningTime = GameSettingsOS.UIScanningTime;
    }
    //return;    
}

simulated function int GetCoopPostGameExperience(bool bWon)
{
    // End:0x100
    if(bWon)
    {
        // End:0x49
        if(DifficultyLevel == 0)
        {
            return class<FoxScoringInfo_OS>(ScoringInfoClass).default.ExpTeamWinEasy;
        }
        // End:0x85
        if(DifficultyLevel == 1)
        {
            return class<FoxScoringInfo_OS>(ScoringInfoClass).default.ExpTeamWinMedium;
        }
        // End:0xC1
        if(DifficultyLevel == 2)
        {
            return class<FoxScoringInfo_OS>(ScoringInfoClass).default.ExpTeamWinHard;
        }
        // End:0xFD
        if(DifficultyLevel == 3)
        {
            return class<FoxScoringInfo_OS>(ScoringInfoClass).default.ExpTeamWinHardcore;
        }
    }
    // End:0x128
    else
    {
        return class<FoxScoringInfo_OS>(ScoringInfoClass).default.ExpTeamLose;
    }
    return 0;
    //return ReturnValue;    
}

function bool DoesGameHavePlayers()
{
    return FoxTeamInfo(Teams[0]).HumanSize > 0;
    //return ReturnValue;    
}

function StartWaves()
{
    //return;    
}

function WaveCompleted()
{
    ++ CurrentWaveIndex;
    ++ LastCompletedWave;
    CurrentWaveSpawnedEnemies = 0;
    CurrentWaveTotalEnemies = 0;
    CurrentWaveKilledEnemies = 0;
    SubWaveIndex = -1;
    TotalSubWaves = 0;
    SubWaveNumEnemies = 0;
    bWaveStarted = false;
    //return;    
}

function WaveStarted(WaveInfo NewWave)
{
    local int I;

    SubWaveIndex = -1;
    TotalSubWaves = NewWave.SubWaves.Length;
    bWaveStarted = true;
    I = 0;
    J0x4D:
    // End:0x10A [Loop If]
    if(I < TotalSubWaves)
    {
        // End:0xB7
        if(I == 0)
        {
            SubWaveNumEnemies = NewWave.SubWaves[I].PrecomputedQueue.Length;
        }
        CurrentWaveTotalEnemies += NewWave.SubWaves[I].PrecomputedQueue.Length;
        ++ I;
        // [Loop Continue]
        goto J0x4D;
    }
    //return;    
}

function EnemiesQueued(int NumQueued)
{
    SubWaveNumEnemies += NumQueued;
    CurrentWaveTotalEnemies += NumQueued;
    //return;    
}

simulated function GameAction(name ObjName, name ActionName)
{
    local array<string> args;
    local PlayerController PC;
    local int Index;
    local string tempAction;

    PC = GetALocalPlayerController();
    // End:0x1B6
    if(((PC != none) && PC.PlayerReplicationInfo != none) && PC.PlayerReplicationInfo.Team != none)
    {
        args.AddItem("DIA_HQ_GameAction");
        args.AddItem(GetAnnouncerName());
        args.AddItem("OnSlaught");
        tempAction = string(ActionName);
        Index = InStr(tempAction, ".");
        // End:0x15F
        if(Index != -1)
        {
            args.AddItem(Left(tempAction, Index));
            args.AddItem(Mid(tempAction, Index + 1));
        }
        // End:0x175
        else
        {
            args.AddItem(tempAction);
        }
        args.AddItem(string(ObjName));
        PC.PostAkDialog(args, true);
    }
    //return;    
}

// Export UFoxGRI_OS::execGetSortedPRIs(FFrame&, void* const)
native simulated function array<FoxPRI> GetSortedPRIs(optional byte TeamIndex, optional bool bForGameEnd)
{
    TeamIndex = 0;                    
}

// Export UFoxGRI_OS::execGetVIPPRI(FFrame&, void* const)
native simulated function FoxPRI GetVIPPRI(int TeamIndex);

// Export UFoxGRI_OS::execGetPRIThreatLevel(FFrame&, void* const)
native simulated function int GetPRIThreatLevel(FoxPRI PRI);

// Export UFoxGRI_OS::execGetTeamBoostMultiplier(FFrame&, void* const)
native simulated function float GetTeamBoostMultiplier(FoxPRI PRI, FoxTypes.EBoostModifierType BoostType);

simulated function StoreGameSpecificSettings(FoxSavedMigrationInfo SavedInfo)
{
    local int I;

    SavedInfo.CurrentWaveIndex = CurrentWaveIndex;
    SavedInfo.LastCompletedWave = LastCompletedWave;
    SavedInfo.TotalWaves = TotalWaves;
    SavedInfo.ActivatedObjectiveCount = ActivatedObjectiveCount;
    SavedInfo.bFirstWaveSpawned = bFirstWaveSpawned;
    I = 0;
    J0xD5:
    // End:0x131 [Loop If]
    if(I < 3)
    {
        SavedInfo.EarnedTokens[I] = EarnedTokens[I];
        ++ I;
        // [Loop Continue]
        goto J0xD5;
    }
    I = 0;
    J0x13C:
    // End:0x196 [Loop If]
    if(I < 4)
    {
        SavedInfo.PlayersJoined[I] = PlayersJoined[I];
        ++ I;
        // [Loop Continue]
        goto J0x13C;
    }
    super(FoxGRI).StoreGameSpecificSettings(SavedInfo);
    //return;    
}

function SetupFromHostMigration()
{
    local int I;

    CurrentWaveIndex = MenuItemsDataStore.HostMigrationInfo.CurrentWaveIndex;
    LastCompletedWave = MenuItemsDataStore.HostMigrationInfo.LastCompletedWave;
    TotalWaves = MenuItemsDataStore.HostMigrationInfo.TotalWaves;
    ActivatedObjectiveCount = MenuItemsDataStore.HostMigrationInfo.ActivatedObjectiveCount - 1;
    bFirstWaveSpawned = MenuItemsDataStore.HostMigrationInfo.bFirstWaveSpawned;
    I = 0;
    J0x141:
    // End:0x1B2 [Loop If]
    if(I < 3)
    {
        EarnedTokens[I] = MenuItemsDataStore.HostMigrationInfo.EarnedTokens[I];
        ++ I;
        // [Loop Continue]
        goto J0x141;
    }
    I = 0;
    J0x1BD:
    // End:0x22C [Loop If]
    if(I < 4)
    {
        PlayersJoined[I] = MenuItemsDataStore.HostMigrationInfo.PlayersJoined[I];
        ++ I;
        // [Loop Continue]
        goto J0x1BD;
    }
    //return;    
}

simulated event ReplicatedEvent(name VarName)
{
    local FoxPC MyFoxPC;
    local FoxHudUI HudUI;
    local FoxPRI MyFoxPRI;

    // End:0xDA
    if((VarName == 'CurrentWaveTotalEnemies') && CurrentWaveTotalEnemies == 0)
    {
        MyFoxPC = FoxPC(GetALocalPlayerController());
        // End:0xD7
        if(MyFoxPC != none)
        {
            MyFoxPRI = FoxPRI(MyFoxPC.PlayerReplicationInfo);
            // End:0xD7
            if((MyFoxPRI != none) && MyFoxPRI.IsStreaming)
            {
                MyFoxPRI.EndVote();
            }
        }
    }
    // End:0x294
    else
    {
        // End:0x294
        if((VarName == 'bWaveStarted') && bWaveStarted == true)
        {
            MyFoxPC = FoxPC(GetALocalPlayerController());
            // End:0x294
            if(MyFoxPC != none)
            {
                MyFoxPRI = FoxPRI(MyFoxPC.PlayerReplicationInfo);
                // End:0x294
                if((MyFoxPRI != none) && MyFoxPRI.IsStreaming)
                {
                    // End:0x294
                    if(CurrentWaveIndex > LastCompletedWave)
                    {
                        // End:0x294
                        if(MyFoxPC.DynamicUI != none)
                        {
                            HudUI = MyFoxPC.DynamicUI.HUD;
                            // End:0x294
                            if((HudUI != none) && HudUI.LiveStreamModWidget != none)
                            {
                                HudUI.LiveStreamModWidget.SetVisible(true);
                                MyFoxPRI.BeginVote();
                            }
                        }
                    }
                }
            }
        }
    }
    super(FoxGRI).ReplicatedEvent(VarName);
    //return;    
}

simulated function bool IsAllowedListEmpty()
{
    local int I;
    local UniqueNetId ZeroId;

    I = 0;
    J0x0B:
    // End:0x53 [Loop If]
    if(I < 4)
    {
        // End:0x45
        if(PlayersJoined[I] != ZeroId)
        {
            return false;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    return true;
    //return ReturnValue;    
}

simulated function bool IsNetIdAllowed(UniqueNetId NetId)
{
    local int I;
    local UniqueNetId ZeroId;

    // End:0x20
    if(NetId == ZeroId)
    {
        return false;
    }
    // End:0x2F
    if(IsInEntryMap())
    {
        return true;
    }
    I = 0;
    J0x3A:
    // End:0x82 [Loop If]
    if(I < 4)
    {
        // End:0x74
        if(PlayersJoined[I] == NetId)
        {
            return true;
        }
        ++ I;
        // [Loop Continue]
        goto J0x3A;
    }
    return false;
    //return ReturnValue;    
}

simulated function bool CanJoinFromSpectate(FoxPC ForPC, optional out string OutErrorMessage, optional bool bCanErrorQueueForSpec)
{
    local FoxPRI PRI;

    bCanErrorQueueForSpec = false;
    PRI = FoxPRI(ForPC.PlayerReplicationInfo);
    // End:0x8E
    if(!IsNetIdAllowed(PRI.UniqueId))
    {
        OutErrorMessage = "invalidjointime_matchstarted";
        return false;
    }
    return super(FoxGRI).CanJoinFromSpectate(ForPC, OutErrorMessage, bCanErrorQueueForSpec);
    //return ReturnValue;    
}

defaultproperties
{
    CurrentWaveIndex=-1
    LastCompletedWave=-1
    TotalWaves=-1
    SubWaveIndex=-1
    ScoringInfoClass=class'FoxScoringInfo_OS'
    GameTypeAudioBanks(0)=AkBank'A_Dialog_Media.SB_DIA_ONS'
    GameTypeCode="OS"
    ReviveTime=4.0
    GameClass=class'FoxGameMP_OS'
}